%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FUNCIONALITAT: %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% A partir de la matriu d'incidencies i de les variables conegudes i %%%%%%
% desconegudes, calcula el rang de les diverses variables, retornant una %%
% matriu amb el rang de les variables, i els zeros. %%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PARMETRES D'ENTRADA: %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% m_incidencies:	matriu d'incidncies del sistema. %%%%%%%%%%%%%%%%%%%%%
% v_desconegudes:   nom de les variables desconegudes. %%%%%%%%%%%%%%%%%%%%
% v_conegudes:      nom de les variables conegudes. %%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PARMETRES DE SORTIDA: %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% m_ranked:     matriu que cont el rang de les variables i els zeros. %%%%
% m_assignat:   matriu amb la constraint que assigna la variable. %%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [m_ranked,m_assignat] = Ranking(m_incidencies,v_desconegudes,v_conegudes)
% Inicialitzacions:
[nc,c] = size(m_incidencies);
nv = c - length(v_conegudes);
m_ranked = ones(nc,2) * -1;
rang = 0;
continuar = 1;
no_rang = zeros(nc,nv);
no_rang(find(m_incidencies(:,1:nv))) = 1;
variables_assignades = 0;
v_assignades = ones(nc,nv) * -1;
v_assignades(find(m_incidencies(:,1:nv))) = 0;
m_assignat = zeros(nc,nv);
% Implementaci:
while continuar == 1
    % Pas 2:
    assignar = [];
    for i = 1:nc
        % Trobem les variables que no tenen rang:
        pos = find(no_rang(i,:));
        % Si noms falta per assignar una variable:
        if length(pos) == 1
            % Acumulem la variable i constraint a marcar:
            assignar = [assignar;i,pos];
        end
    end
    % Pas 3:
    for i = 1:nc
        % Trobem les variables que no tenen rang
        pos_r = find(v_assignades(i,:) == 0);
        % Si totes les variables estan assignades
        if (isempty(pos_r)) && (m_ranked(i,2) == -1)
            % Indiquem que s un ZERO
            m_ranked(i,1) = 1;
            % Assignem el rang
            m_ranked(i,2) = rang;
        end
    end
    [f,c] = size(assignar);
    % Per cada parella variable constraint que haguem d'assignar
    for i = 1:f
        % Marquem la constraint:
        no_rang(assignar(i,1),:) = 0;
        % Marquem la variable:
        no_rang(:,assignar(i,2)) = 0;
        % Afegim el rang a la constraint:
        m_ranked(assignar(i,1),2) = rang;
        % Incrementem el nombre de variables assignades:
        variables_assignades = variables_assignades + 1;
        v_assignades(find(m_incidencies(:,assignar(i,2))),assignar(i,2)) = 1;
        m_assignat(assignar(i,1),assignar(i,2)) = 1;
    end
    % Pas 4:
    rang = rang + 1;
    % Pas 5:
    ncr = find(m_ranked(:,2) == -1);
    % Si no queden constraints per assingar un rang acabem
    if (length(ncr) == 0) && (variables_assignades == nv)
        continuar = 0;
    end
end