%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% pos_constraint(Graph,variable_buscar) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FUNCIONALITAT: %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Retorna la posici de la constraint que dna valor a la variables que %%%
% busquem. %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PARMETRES D'ENTRADA: %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Graph:            Estructura on tenim totes les relacions entre cons- %%%
%                   traints i variables. %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% variable_buscar:  Variable de sortida que volem trobar la constraint %%%%
%                   que li assigna el seu valor. %%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PARMETRES DE SORTIDA: %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% pc:   Posici que ocupa la constraint que ens dna valor a la variable. %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function pc = pos_constraint(Graph,variable_buscar)
% Inicialitzacions:
continuar = 1;
pc = 1;
% Implementaci:
while continuar == 1
    % Mirem si la variable que busquem s la sortida del subgraph actual
    if strcmp(Graph.Subgraph{pc}.Sortida,variable_buscar)
        % Hem trobat la constraint
        continuar = 0;
    else
        % Continuem buscant
        pc = pc + 1;
        if pc > length(Graph.Subgraph)
            continuar = 0;
            pc = -1;
        end
    end
end