% Script per a la simulaci de retards
clear all, clc;

% Obtenci de les dades a simular en condicions normals
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Ae3 = 'AdqDades\\PT2\\C2\\Tm1000Gt100\\jueves_11_44_44_Eq3.xls';
e3 = load (Ae3);
ANivells = 'AdqDades\\PT2\\C2\\Tm1000Gt100\\jueves_11_44_44_Nivells.xls';
Nivells = load (ANivells);
AControls = 'AdqDades\\PT2\\C2\\Tm1000Gt100\\jueves_11_44_44_Controls.xls';
Controls = load (AControls);

% Parametres generals del model
%-------------------------------
A = 332.5;                          % Area dels diposits cm*cm
Hi2 = Nivells(4:length(e3)-1,1);    % Valor inicial de l'alada del tanc T2
Hi3 = Nivells(4:length(e3)-1,3);	% Valor inicial de l'alada del tanc T3
T = 1.2;                            % Temps de mostreig 
CB3 = Controls(5:length(e3),1);     % Consigna bomba 3
k1 = 6.1809;                        % Prdua crrega V10
k2 = 4.9253;                        % Prdua crrega V9
k3 = 8.7201;                        % Prdua crrega VR1


% Formaci de dades
%%%%%%%%%%%%%%%%%%%
C = e3(5:length(e3),2);          % Cabal bomba 3
H2= Nivells(5:length(e3),1);     % Nivell del tanc 2
H3= Nivells(5:length(e3),3);     % Nivell del tanc 3
% dH2 = (H2 - Hi2) / T;            % Derivada Nivell tanc 2
% dH3 = (H3 - Hi3) / T;            % Derivada Nivell tanc 3

% Crrega dels llindars
%%%%%%%%%%%%%%%%%%%%%%%
load Llindars;

% Definici dels retards
%%%%%%%%%%%%%%%%%%%%%%%%

% C(11:15) = [C(10) C(10) C(10) C(10) C(10)];
% CB3(11:15) = [CB3(10) CB3(10) CB3(10) CB3(10) CB3(10)];

% H2(11:15) = [H2(10) H2(10) H2(10) H2(10) H2(10)];
% dH2(11:15) = [dH2(10) dH2(10) dH2(10) dH2(10) dH2(10)];

% H3(11:15) = [H3(10) H3(10) H3(10) H3(10) H3(10)];
% dH3(11:15) = [dH3(10) dH3(10) dH3(10) dH3(10) dH3(10)];

dH2 = (H2 - Hi2) / T;            % Derivada Nivell tanc 2
dH3 = (H3 - Hi3) / T;            % Derivada Nivell tanc 3

% Definici de les equacions de redundncia
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ARR1 = C - k1 * sqrt(H3 - 13) - k2 * sqrt(H3 - H2) - A * dH3;
ARR2 = k1 * sqrt(H3 - 13) + k2 * sqrt(H3 - H2) - k3 * sqrt(H2) - A * dH2;
ARR3 = (0.0031 * CB3 .^ 2 + 0.0163 * CB3 + 17.612) - C;

% ARR1(1:10) = ARR1(length(ARR1) - 9:length(ARR1));
% ARR2(1:10) = ARR2(length(ARR2) - 9:length(ARR2));
% ARR3(1:10) = ARR3(length(ARR3) - 9:length(ARR3));

% Representaci dels residus
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure;
% ARR1
subplot(3,1,1), plot(ARR1);
title('Residus del sistema amb gotera');
xlabel('Temps (s)');
ylabel('ARR1');

% Llindars
line([1,length(ARR1)],[LlindarSuperiorARR1, LlindarSuperiorARR1], 'color', 'k', 'LineStyle', '--');
line([1,length(ARR1)],[LlindarInferiorARR1, LlindarInferiorARR1], 'color', 'k', 'LineStyle', '--');

% % Retards
% line([11,15],[max(ARR1 + .1), max(ARR1 + .1)],'color', 'm', 'LineStyle', '--');
% line([11,15],[min(ARR1 - .1), min(ARR1 - .1)],'color', 'm', 'LineStyle', '--');
% line([11,11],[max(ARR1 + .1), min(ARR1 - .1)],'color', 'm', 'LineStyle', '--');
% line([15,15],[max(ARR1 + .1), min(ARR1 - .1)],'color', 'm', 'LineStyle', '--');

% Fallada
line([1,40],[max(ARR1 + .1), max(ARR1 + .1)],'color', 'r', 'LineStyle', '--');
line([1,40],[min(ARR1 - .1), min(ARR1 - .1)],'color', 'r', 'LineStyle', '--');
line([1,1],[max(ARR1 + .1), min(ARR1 - .1)],'color', 'r', 'LineStyle', '--');
line([40,40],[max(ARR1 + .1), min(ARR1 - .1)],'color', 'r', 'LineStyle', '--');

% Recuperaci
line([40,79],[max(ARR1 + .1), max(ARR1 + .1)],'color', 'g', 'LineStyle', '--');
line([40,79],[min(ARR1 - .1), min(ARR1 - .1)],'color', 'g', 'LineStyle', '--');
line([40,40],[max(ARR1 + .1), min(ARR1 - .1)],'color', 'g', 'LineStyle', '--');
line([79,79],[max(ARR1 + .1), min(ARR1 - .1)],'color', 'g', 'LineStyle', '--');

% ARR2
subplot(3,1,2), plot(ARR2);
xlabel('Temps (s)');
ylabel('ARR2');

% Llindars
line([1,length(ARR2)],[LlindarSuperiorARR2, LlindarSuperiorARR2], 'color', 'k', 'LineStyle', '--');
line([1,length(ARR2)],[LlindarInferiorARR2, LlindarInferiorARR2], 'color', 'k', 'LineStyle', '--');

% % Retards
% line([11,15],[max(ARR2 + .1), max(ARR2 + .1)],'color', 'm', 'LineStyle', '--');
% line([11,15],[min(ARR2 - .1), min(ARR2 - .1)],'color', 'm', 'LineStyle', '--');
% line([11,11],[max(ARR2 + .1), min(ARR2 - .1)],'color', 'm', 'LineStyle', '--');
% line([15,15],[max(ARR2 + .1), min(ARR2 - .1)],'color', 'm', 'LineStyle', '--');

% Fallada
line([1,40],[max(ARR2 + .1), max(ARR2 + .1)],'color', 'r', 'LineStyle', '--');
line([1,40],[min(ARR2 - .1), min(ARR2 - .1)],'color', 'r', 'LineStyle', '--');
line([1,1],[max(ARR2 + .1), min(ARR2 - .1)],'color', 'r', 'LineStyle', '--');
line([40,40],[max(ARR2 + .1), min(ARR2 - .1)],'color', 'r', 'LineStyle', '--');

% Recuperaci
line([40,79],[max(ARR2 + .1), max(ARR2 + .1)],'color', 'g', 'LineStyle', '--');
line([40,79],[min(ARR2 - .1), min(ARR2 - .1)],'color', 'g', 'LineStyle', '--');
line([40,40],[max(ARR2 + .1), min(ARR2 - .1)],'color', 'g', 'LineStyle', '--');
line([79,79],[max(ARR2 + .1), min(ARR2 - .1)],'color', 'g', 'LineStyle', '--');

% ARR3
subplot(3,1,3), plot(ARR3);
xlabel('Temps (s)');
ylabel('ARR3');

% Llindars
line([1,length(ARR3)],[LlindarSuperiorARR3, LlindarSuperiorARR3], 'color', 'k', 'LineStyle', '--');
line([1,length(ARR3)],[LlindarInferiorARR3, LlindarInferiorARR3], 'color', 'k', 'LineStyle', '--');

% % Retards
% line([11,15],[max(ARR3 + .1), max(ARR3 + .1)],'color', 'm', 'LineStyle', '--');
% line([11,15],[min(ARR3 - .1), min(ARR3 - .1)],'color', 'm', 'LineStyle', '--');
% line([11,11],[max(ARR3 + .1), min(ARR3 - .1)],'color', 'm', 'LineStyle', '--');
% line([15,15],[max(ARR3 + .1), min(ARR3 - .1)],'color', 'm', 'LineStyle', '--');

% Fallada
line([1,40],[max(ARR3 + .1), max(ARR3 + .1)],'color', 'r', 'LineStyle', '--');
line([1,40],[min(ARR3 - .1), min(ARR3 - .1)],'color', 'r', 'LineStyle', '--');
line([1,1],[max(ARR3 + .1), min(ARR3 - .1)],'color', 'r', 'LineStyle', '--');
line([40,40],[max(ARR3 + .1), min(ARR3 - .1)],'color', 'r', 'LineStyle', '--');

% Recuperaci
line([40,79],[max(ARR3 + .1), max(ARR3 + .1)],'color', 'g', 'LineStyle', '--');
line([40,79],[min(ARR3 - .1), min(ARR3 - .1)],'color', 'g', 'LineStyle', '--');
line([40,40],[max(ARR3 + .1), min(ARR3 - .1)],'color', 'g', 'LineStyle', '--');
line([79,79],[max(ARR3 + .1), min(ARR3 - .1)],'color', 'g', 'LineStyle', '--');

% Representaci de la signatura
S1 = Histograma(ARR1(1:40), LlindarSuperiorARR1, LlindarInferiorARR1);
S2 = Histograma(ARR2(1:40), LlindarSuperiorARR2, LlindarInferiorARR2);
S3 = Histograma(ARR3(1:40), LlindarSuperiorARR3, LlindarInferiorARR3);

figure;
% ARR1
subplot(3,1,1), bar(S1);
title('Signatura del sistema amb gotera');
ylabel('% valors ARR1');
h = findobj(gca,'Type','patch');
set(h,'FaceColor',[.75,.75,.75],'EdgeColor','k');
set(gca, 'XTick', [1,2,3], 'XTickLabel', {'-1','0','+1'});

% ARR2
subplot(3,1,2), bar(S2);
ylabel('% valors ARR2');
h = findobj(gca,'Type','patch');
set(h,'FaceColor',[.75,.75,.75],'EdgeColor','k');
set(gca, 'XTick', [1,2,3], 'XTickLabel', {'-1','0','+1'});

% ARR3
subplot(3,1,3), bar(S3);
ylabel('% valors ARR3');
h = findobj(gca,'Type','patch');
set(h,'FaceColor',[.75,.75,.75],'EdgeColor','k');
set(gca, 'XTick', [1,2,3], 'XTickLabel', {'-1','0','+1'});

% ARR1m = reduccio_retards(ARR1,5,LlindarInferiorARR1,LlindarSuperiorARR1);
% ARR2m = reduccio_retards(ARR2,5,LlindarInferiorARR2,LlindarSuperiorARR2);
% ARR3m = reduccio_retards(ARR3,5,LlindarInferiorARR3,LlindarSuperiorARR3);
% 
% % Representaci dels resultats
% % ARR1:
% figure;
% subplot(3,1,1), plot(ARR1m);
% title('Sistema dels 3 tancs: Gotera tanc T3 amb retards en nivell T2');
% xlabel('Temps (s)');
% ylabel('ARR1');
% 
% % Llindars
% line([1,length(ARR1)],[LlindarSuperiorARR1, LlindarSuperiorARR1], 'color', 'k', 'LineStyle', '--');
% line([1,length(ARR1)],[LlindarInferiorARR1, LlindarInferiorARR1], 'color', 'k', 'LineStyle', '--');
% 
% % Retards
% line([11,15],[max(ARR1m + .1), max(ARR1m + .1)],'color', 'm', 'LineStyle', '--');
% line([11,15],[min(ARR1m - .1), min(ARR1m - .1)],'color', 'm', 'LineStyle', '--');
% line([11,11],[max(ARR1m + .1), min(ARR1m - .1)],'color', 'm', 'LineStyle', '--');
% line([15,15],[max(ARR1m + .1), min(ARR1m - .1)],'color', 'm', 'LineStyle', '--');
% 
% % Falla
% line([1,40],[max(ARR1m + .1), max(ARR1m + .1)],'color', 'r', 'LineStyle', '--');
% line([1,40],[min(ARR1m - .1), min(ARR1m - .1)],'color', 'r', 'LineStyle', '--');
% line([1,1],[max(ARR1m + .1), min(ARR1m - .1)],'color', 'r', 'LineStyle', '--');
% line([40,40],[max(ARR1m + .1), min(ARR1m - .1)],'color', 'r', 'LineStyle', '--');
% 
% % Recuperaci
% line([40,79],[max(ARR1m + .1), max(ARR1m + .1)],'color', 'g', 'LineStyle', '--');
% line([40,79],[min(ARR1m - .1), min(ARR1m - .1)],'color', 'g', 'LineStyle', '--');
% line([40,40],[max(ARR1m + .1), min(ARR1m - .1)],'color', 'g', 'LineStyle', '--');
% line([79,79],[max(ARR1m + .1), min(ARR1m - .1)],'color', 'g', 'LineStyle', '--');
% 
% % ARR2:
% subplot(3,1,2), plot(ARR2m);
% xlabel('Temps (s)');
% ylabel('ARR2');
% 
% % Llindars
% line([1,length(ARR2)],[LlindarSuperiorARR2, LlindarSuperiorARR2], 'color', 'k', 'LineStyle', '--');
% line([1,length(ARR2)],[LlindarInferiorARR2, LlindarInferiorARR2], 'color', 'k', 'LineStyle', '--');
% 
% % Retards
% line([11,15],[max(ARR2m + .1), max(ARR2m + .1)],'color', 'm', 'LineStyle', '--');
% line([11,15],[min(ARR2m - .1), min(ARR2m - .1)],'color', 'm', 'LineStyle', '--');
% line([11,11],[max(ARR2m + .1), min(ARR2m - .1)],'color', 'm', 'LineStyle', '--');
% line([15,15],[max(ARR2m + .1), min(ARR2m - .1)],'color', 'm', 'LineStyle', '--');
% 
% % Falla
% line([1,40],[max(ARR2m + .1), max(ARR2m + .1)],'color', 'r', 'LineStyle', '--');
% line([1,40],[min(ARR2m - .1), min(ARR2m - .1)],'color', 'r', 'LineStyle', '--');
% line([1,1],[max(ARR2m + .1), min(ARR2m - .1)],'color', 'r', 'LineStyle', '--');
% line([40,40],[max(ARR2m + .1), min(ARR2m - .1)],'color', 'r', 'LineStyle', '--');
% 
% % Recuperaci
% line([40,79],[max(ARR2m + .1), max(ARR2m + .1)],'color', 'g', 'LineStyle', '--');
% line([40,79],[min(ARR2m - .1), min(ARR2m - .1)],'color', 'g', 'LineStyle', '--');
% line([40,40],[max(ARR2m + .1), min(ARR2m - .1)],'color', 'g', 'LineStyle', '--');
% line([79,79],[max(ARR2m + .1), min(ARR2m - .1)],'color', 'g', 'LineStyle', '--');
% 
% % ARR3:
% subplot(3,1,3), plot(ARR3m);
% xlabel('Temps (s)');
% ylabel('ARR3');
% 
% % Llindars
% line([1,length(ARR3)],[LlindarSuperiorARR3, LlindarSuperiorARR3], 'color', 'k', 'LineStyle', '--');
% line([1,length(ARR3)],[LlindarInferiorARR3, LlindarInferiorARR3], 'color', 'k', 'LineStyle', '--');
% 
% % Retards
% line([11,15],[max(ARR3m + .1), max(ARR3m + .1)],'color', 'm', 'LineStyle', '--');
% line([11,15],[min(ARR3m - .1), min(ARR3m - .1)],'color', 'm', 'LineStyle', '--');
% line([11,11],[max(ARR3m + .1), min(ARR3m - .1)],'color', 'm', 'LineStyle', '--');
% line([15,15],[max(ARR3m + .1), min(ARR3m - .1)],'color', 'm', 'LineStyle', '--');
% 
% % Falla
% line([1,40],[max(ARR3m + .1), max(ARR3m + .1)],'color', 'r', 'LineStyle', '--');
% line([1,40],[min(ARR3m - .1), min(ARR3m - .1)],'color', 'r', 'LineStyle', '--');
% line([1,1],[max(ARR3m + .1), min(ARR3m - .1)],'color', 'r', 'LineStyle', '--');
% line([40,40],[max(ARR3m + .1), min(ARR3m - .1)],'color', 'r', 'LineStyle', '--');
% 
% % Recuperaci
% line([40,79],[max(ARR3m + .1), max(ARR3m + .1)],'color', 'g', 'LineStyle', '--');
% line([40,79],[min(ARR3m - .1), min(ARR3m - .1)],'color', 'g', 'LineStyle', '--');
% line([40,40],[max(ARR3m + .1), min(ARR3m - .1)],'color', 'g', 'LineStyle', '--');
% line([79,79],[max(ARR3m + .1), min(ARR3m - .1)],'color', 'g', 'LineStyle', '--');