function Y = Histograma(Dades, LlindarSuperior, LlindarInferior)
%--------------------------------------------------------------------------
% Aquesta funci s'encarrega de realitzar un histograma a partir del
% parmetre dades. La divisi en intervals es realitza en 3 subdivisions:
%   - Valors per sota o iguals al llindar inferior
%   - Valors entre el llindar inferior i el llindar superior
%   - Valors per sobre o iguals al llindar superior.
% Parmetres:
% -----------
%   Dades:  Valors sobre els que hem de calcular l'histograma.
%   LlindarSuperior:    Valor del llindar superior de la distribuci.
%   LlindarInferior.    Valor del llindar inferior de la distribuci.
%--------------------------------------------------------------------------
tamany = length(Dades);
inferiors = 0;
interiors = 0;
superiors = 0;
for i = 1:tamany
    if Dades(i) <= LlindarInferior
        inferiors = inferiors + 1;
    elseif Dades(i) < LlindarSuperior
        interiors = interiors + 1;
    else
        superiors = superiors + 1;   
    end
end
inferiors = (inferiors / tamany) * 100; 
interiors = (interiors / tamany) * 100; 
superiors = (superiors / tamany) * 100; 
Y = [inferiors interiors superiors];   