%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Model 1 Tanc %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Fallada en el sensor de cabal i retards en nivell del tanc (i derivada)

Ae3 = 'CapDades\\jueves_08_15_56_Eq3.xls';
e3 = load (Ae3);
ANivells = 'CapDades\\jueves_08_15_56_Nivells.xls';
Nivells = load (ANivells);
AControls = 'CapDades\\jueves_08_15_56_Controls.xls';
Controls = load (AControls);
% Fallada en el sensor de cabal
e3(200:300,2) = e3(200:300,2) * 0.85;

% Parametres generals del model
%-------------------------------------------------
Him=[(1:length(e3)-1)' Nivells(1:length(e3)-1,3)];      % Valor inicial de l'alada del tanc T3
tsim=length(e3)-1;                                      % Temps que ha de durar la simulaci 

%%%%%Formaci de dades%%%%%%
Qim=[(1:length(e3)-1)' e3(2:length(e3),2)];
Hm=[(1:length(e3)-1)' Nivells(2:length(e3),3)];
CB3=[(1:length(e3)-1)' Controls(2:length(e3),1)];       % Consigna bomba 3

%Interpolaci de les dades amb soroll
h1 = Him(1:198,2);
hin = [21.35;21.357;21.365;21.372;21.380];
h2 = Him(205:223,2);
hin2 = [21.379;21.380;21.381;21.3815;21.382;21.381;21.379];
h3 = Him(230:length(Him),2);
H = [h1;hin;h2;hin2;h3];
Hmi = H(1:length(H)-1);
Hi = H(2:length(H));

derivada = (Hi - Hmi) / 1.2;
derivada = [derivada(1);derivada(1:length(derivada) - 1)];

% Mostreig de dades
Final = tsim;
j = 1;
for i = 1:Final-5
    qi = Qim(i:i+4,2);
    qi = sort(qi);
    QF(j) = mean(qi(2:4));
    hi = Hi(i:i+4);
    hi = sort(hi);
    HF(j) = mean(hi(2:4));
    di = derivada(i:i+4);
    di = sort(di);
    dF(j) = mean(di(2:4));
    cbf = CB3(i:i+4,2);
    cbf = sort(cbf);
    CBF(j) = mean(cbf(2:4));
    j = j + 1;
end
j = 1;
Final = Final - 5;
for i = 1:3:Final-1
    QF1(j) = QF(i);
    HF1(j) = HF(i);
    dF1(j) = dF(i);
    CBF1(j) = CBF(i);
    j = j + 1;
end
QF = QF1; HF = HF1; dF = dF1; CBF = CBF1;

% % Introducci de retards
% 
% HF(51:55) = [HF(50) HF(50) HF(50) HF(50) HF(50)];
% dF(51:55) = [dF(50) dF(50) dF(50) dF(50) dF(50)];
% 
% HF(71:75) = [HF(70) HF(70) HF(70) HF(70) HF(70)];
% dF(71:75) = [dF(70) dF(70) dF(70) dF(70) dF(70)];
% 
% HF(81:85) = [HF(80) HF(80) HF(80) HF(80) HF(80)];
% dF(81:85) = [dF(80) dF(80) dF(80) dF(80) dF(80)];

ARRf = QF - (6.1809 * sqrt(HF - 2.5)) - (332.5 * dF);
ARR2 = (0.0031*CBF.^2+0.0163*CBF+17.612) - QF;
% LlindarARR2 = 3 * std(ARR2);
% LlindarSuperiorARR2 = LlindarARR2 + mean(ARR2);
% LlindarInferiorARR2 = -(LlindarARR2 - mean(ARR2));
% load Llindars;
% load LlindarsSO;
load LlindarsModelSimple;

% Representaci de les dades
figure;
subplot(2,1,1),plot(ARRf);
% title('Model 1 Tanc: Sistema Amb 1 Retard (Duraci 5) i Sense Fallades');
% title('Sistema amb retards i fallada del sensor de cabal');
% title('1 Tanc Model: System with delays in level values with flow sensor failure');
title('Model simple: Sistema amb fallada en el sensor de cabal');
xlabel('Temps (s)');
% xlabel('Time (s)');
ylabel('ARR1');
% % Retard
% line([50,55],[max(ARRf)+.1,max(ARRf)+.1],'color','r','LineStyle','--');
% line([50,55],[min(ARRf)-.1,min(ARRf)-.1],'color','r','LineStyle','--');
% line([50,50],[min(ARRf)-.1,max(ARRf)+.1],'color','r','LineStyle','--');
% line([55,55],[max(ARRf)+.1,min(ARRf)-.1],'color','r','LineStyle','--');
% 
% line([70,75],[max(ARRf)+.1,max(ARRf)+.1],'color','r','LineStyle','--');
% line([70,75],[min(ARRf)-.1,min(ARRf)-.1],'color','r','LineStyle','--');
% line([70,70],[min(ARRf)-.1,max(ARRf)+.1],'color','r','LineStyle','--');
% line([75,75],[max(ARRf)+.1,min(ARRf)-.1],'color','r','LineStyle','--');
% 
% line([80,85],[max(ARRf)+.1,max(ARRf)+.1],'color','r','LineStyle','--');
% line([80,85],[min(ARRf)-.1,min(ARRf)-.1],'color','r','LineStyle','--');
% line([80,80],[min(ARRf)-.1,max(ARRf)+.1],'color','r','LineStyle','--');
% line([85,85],[max(ARRf)+.1,min(ARRf)-.1],'color','r','LineStyle','--');

% Fallada del sensor de cabal
line([66,99],[max(ARRf)+.3,max(ARRf)+.3],'color','g','LineStyle','--');
line([66,99],[min(ARRf)-.3,min(ARRf)-.3],'color','g','LineStyle','--');
line([66,66],[min(ARRf)-.3,max(ARRf)+.3],'color','g','LineStyle','--');
line([99,99],[max(ARRf)+.3,min(ARRf)-.3],'color','g','LineStyle','--');

% Canvi de consigna
line([41,41],[max(ARRf)+.1,min(ARRf)-.1],'color','m','LineStyle','--');

% Llindars
line([1,Final/3],[LlindarSuperior,LlindarSuperior],'color','k','LineStyle','--');
line([1,Final/3],[LlindarInferior,LlindarInferior],'color','k','LineStyle','--');

% % Nous llindars
% line([1,Final/3],[.1,.1],'color','c','LineStyle','--');
% line([1,Final/3],[13,13],'color','c','LineStyle','--');

subplot(2,1,2),plot(ARR2);

xlabel('Temps (s)');
% xlabel('Time (s)');
ylabel('ARR2');
% % Retard
% line([50,55],[max(ARR2)+.1,max(ARR2)+.1],'color','r','LineStyle','--');
% line([50,55],[min(ARR2)-.1,min(ARR2)-.1],'color','r','LineStyle','--');
% line([50,50],[min(ARR2)-.1,max(ARR2)+.1],'color','r','LineStyle','--');
% line([55,55],[max(ARR2)+.1,min(ARR2)-.1],'color','r','LineStyle','--');
% 
% line([70,75],[max(ARR2)+.1,max(ARR2)+.1],'color','r','LineStyle','--');
% line([70,75],[min(ARR2)-.1,min(ARR2)-.1],'color','r','LineStyle','--');
% line([70,70],[min(ARR2)-.1,max(ARR2)+.1],'color','r','LineStyle','--');
% line([75,75],[max(ARR2)+.1,min(ARR2)-.1],'color','r','LineStyle','--');
% 
% line([80,85],[max(ARR2)+.1,max(ARR2)+.1],'color','r','LineStyle','--');
% line([80,85],[min(ARR2)-.1,min(ARR2)-.1],'color','r','LineStyle','--');
% line([80,80],[min(ARR2)-.1,max(ARR2)+.1],'color','r','LineStyle','--');
% line([85,85],[max(ARR2)+.1,min(ARR2)-.1],'color','r','LineStyle','--');

% Fallada del sensor de cabal
line([66,99],[max(ARR2)+.3,max(ARR2)+.3],'color','g','LineStyle','--');
line([66,99],[min(ARR2)-.3,min(ARR2)-.3],'color','g','LineStyle','--');
line([66,66],[min(ARR2)-.3,max(ARR2)+.3],'color','g','LineStyle','--');
line([99,99],[max(ARR2)+.3,min(ARR2)-.3],'color','g','LineStyle','--');

% Canvi de consigna
line([41,41],[max(ARR2)+.1,min(ARR2)-.1],'color','m','LineStyle','--');

% Llindars
line([1,Final/3],[LlindarSuperiorARR2,LlindarSuperiorARR2],'color','k','LineStyle','--');
line([1,Final/3],[LlindarInferiorARR2,LlindarInferiorARR2],'color','k','LineStyle','--');

% subplot(3,1,3),plot(HF);
% xlabel('Temps (s)');
% % xlabel('Time (s)');
% ylabel('Nivell Tanc (cm)');
% % ylabel('Tanc Level (cm)');
% % Retard
% line([50,55],[max(HF)+.1,max(HF)+.1],'color','r','LineStyle','--');
% line([50,55],[min(HF)-.1,min(HF)-.1],'color','r','LineStyle','--');
% line([50,50],[min(HF)-.1,max(HF)+.1],'color','r','LineStyle','--');
% line([55,55],[max(HF)+.1,min(HF)-.1],'color','r','LineStyle','--');
% 
% line([70,75],[max(HF)+.1,max(HF)+.1],'color','r','LineStyle','--');
% line([70,75],[min(HF)-.1,min(HF)-.1],'color','r','LineStyle','--');
% line([70,70],[min(HF)-.1,max(HF)+.1],'color','r','LineStyle','--');
% line([75,75],[max(HF)+.1,min(HF)-.1],'color','r','LineStyle','--');
% 
% line([80,85],[max(HF)+.1,max(HF)+.1],'color','r','LineStyle','--');
% line([80,85],[min(HF)-.1,min(HF)-.1],'color','r','LineStyle','--');
% line([80,80],[min(HF)-.1,max(HF)+.1],'color','r','LineStyle','--');
% line([85,85],[max(HF)+.1,min(HF)-.1],'color','r','LineStyle','--');

% % Consigna
% line([1,Final/3],[21,21],'color','y','LineStyle','--');

% % Canvi de consigna
% line([41,41],[max(HF)+.1,min(HF)-.1],'color','m','LineStyle','--');

h1 = Histograma(ARRf(66:99),LlindarSuperior,LlindarInferior);
h2 = Histograma(ARR2(66:99),LlindarSuperiorARR2,LlindarInferiorARR2);

% Signatura dels residus
% ARR1:
figure;
subplot(2,1,1), bar(h1);
title('Signatura Model Simple fallada en el sensor de cabal');
ylabel('ARR1');
h = findobj(gca,'Type','patch');
set(h,'FaceColor',[.75,.75,.75],'EdgeColor','k');
set(gca,'XTick',[1 2 3],'XTickLabel',{'-1','0','1'},'FontSize',10);

% ARR2:
subplot(2,1,2), bar(h2);
ylabel('ARR2');
h = findobj(gca,'Type','patch');
set(h,'FaceColor',[.75,.75,.75],'EdgeColor','k');
set(gca,'XTick',[1 2 3],'XTickLabel',{'-1','0','1'},'FontSize',10);

% w = 5;
% ARRm = reduccio_retards(ARRf,5,LlindarInferior,LlindarSuperior);
% 
% % Representaci de les dades
% figure;
% subplot(2,1,1),plot(ARRm);
% % t = sprintf('Model 1 Tanc: Sistema Amb 1 Retard (Duraci 5) i Sense Fallades w = %d',w);
% t = sprintf('1 Tanc Model: System with delays in level values with flow sensor failure. w = %d',w);
% % t = sprintf('1 Tanc Model: System with delays(Length = 5) without failures. w = %d',w);
% title(t);
% % xlabel('Temps (s)');
% xlabel('Time (s)');
% ylabel('ARR1');
% % Retard
% line([50,55],[max(ARRm)+.1,max(ARRm)+.1],'color','r','LineStyle','--');
% line([50,55],[min(ARRm)-.1,min(ARRm)-.1],'color','r','LineStyle','--');
% line([50,50],[min(ARRm)-.1,max(ARRm)+.1],'color','r','LineStyle','--');
% line([55,55],[max(ARRm)+.1,min(ARRm)-.1],'color','r','LineStyle','--');
% 
% line([70,75],[max(ARRm)+.1,max(ARRm)+.1],'color','r','LineStyle','--');
% line([70,75],[min(ARRm)-.1,min(ARRm)-.1],'color','r','LineStyle','--');
% line([70,70],[min(ARRm)-.1,max(ARRm)+.1],'color','r','LineStyle','--');
% line([75,75],[max(ARRm)+.1,min(ARRm)-.1],'color','r','LineStyle','--');
% 
% line([80,85],[max(ARRm)+.1,max(ARRm)+.1],'color','r','LineStyle','--');
% line([80,85],[min(ARRm)-.1,min(ARRm)-.1],'color','r','LineStyle','--');
% line([80,80],[min(ARRm)-.1,max(ARRm)+.1],'color','r','LineStyle','--');
% line([85,85],[max(ARRm)+.1,min(ARRm)-.1],'color','r','LineStyle','--');
% 
% % % Fallada del sensor de cabal
% line([66,99],[max(ARRm)+.3,max(ARRm)+.3],'color','g','LineStyle','--');
% line([66,99],[min(ARRm)-.3,min(ARRm)-.3],'color','g','LineStyle','--');
% line([66,66],[min(ARRm)-.3,max(ARRm)+.3],'color','g','LineStyle','--');
% line([99,99],[max(ARRm)+.3,min(ARRm)-.3],'color','g','LineStyle','--');
% 
% % Llindars
% line([1,Final/3],[LlindarSuperior,LlindarSuperior],'color','k','LineStyle','--');
% line([1,Final/3],[LlindarInferior,LlindarInferior],'color','k','LineStyle','--');
% 
% ARRm2 = reduccio_retards(ARR2,5,LlindarInferiorARR2,LlindarSuperiorARR2);
% 
% subplot(2,1,2),plot(ARRm2);
% % t = sprintf('Model 1 Tanc: Sistema Amb 1 Retard (Duraci 5) i Sense Fallades w = %d',w);
% % t = sprintf('1 Tanc Model: System with delays in level values with flow sensor failure. w = %d',w);
% % t = sprintf('1 Tanc Model: System with delays(Length = 5) without failures. w = %d',w);
% % title(t);
% % xlabel('Temps (s)');
% xlabel('Time (s)');
% ylabel('ARR2');
% % Retard
% line([50,55],[max(ARRm2)+.1,max(ARRm2)+.1],'color','r','LineStyle','--');
% line([50,55],[min(ARRm2)-.1,min(ARRm2)-.1],'color','r','LineStyle','--');
% line([50,50],[min(ARRm2)-.1,max(ARRm2)+.1],'color','r','LineStyle','--');
% line([55,55],[max(ARRm2)+.1,min(ARRm2)-.1],'color','r','LineStyle','--');
% 
% line([70,75],[max(ARRm2)+.1,max(ARRm2)+.1],'color','r','LineStyle','--');
% line([70,75],[min(ARRm2)-.1,min(ARRm2)-.1],'color','r','LineStyle','--');
% line([70,70],[min(ARRm2)-.1,max(ARRm2)+.1],'color','r','LineStyle','--');
% line([75,75],[max(ARRm2)+.1,min(ARRm2)-.1],'color','r','LineStyle','--');
% 
% line([80,85],[max(ARRm2)+.1,max(ARRm2)+.1],'color','r','LineStyle','--');
% line([80,85],[min(ARRm2)-.1,min(ARRm2)-.1],'color','r','LineStyle','--');
% line([80,80],[min(ARRm2)-.1,max(ARRm2)+.1],'color','r','LineStyle','--');
% line([85,85],[max(ARRm2)+.1,min(ARRm2)-.1],'color','r','LineStyle','--');
% 
% % % Fallada del sensor de cabal
% line([66,99],[max(ARRm2)+.3,max(ARRm2)+.3],'color','g','LineStyle','--');
% line([66,99],[min(ARRm2)-.3,min(ARRm2)-.3],'color','g','LineStyle','--');
% line([66,66],[min(ARRm2)-.3,max(ARRm2)+.3],'color','g','LineStyle','--');
% line([99,99],[max(ARRm2)+.3,min(ARRm2)-.3],'color','g','LineStyle','--');
% 
% % Llindars
% line([1,Final/3],[LlindarSuperiorARR2,LlindarSuperiorARR2],'color','k','LineStyle','--');
% line([1,Final/3],[LlindarInferiorARR2,LlindarInferiorARR2],'color','k','LineStyle','--');