%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% fred = reduccio_retards(f,w,LlindarInferior,LlindarSuperior) %%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FUNCIONALITAT: %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Funci per reduir els efectes dels retards en una funci. %%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PARMETRES D'ENTRADA: %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% f:                Funci a la que li volem reduir els efectes dels %%%%%%
%                   retards. %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% w:                Tamany de la finestra temporal a utilitzar. %%%%%%%%%%%
% LlindarInferior:  Valor del lmit inferior per decidir si un valor est %
%                   per sota de la zona de zeros. %%%%%%%%%%%%%%%%%%%%%%%%%
% LlindarSuperior:  Valor del lmit superior per decidir si un valor est %
%                   per sobre de la zona de zeros. %%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PARMETRS DE SORTIDA: %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% fred: Resultat de reduir els efectes dels retards dels valors d'entrada.%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function fred = reduccio_retards(f, w, LlindarInferior, LlindarSuperior)
% Emplenem la finestra temporal
for i = 1:w
%     if (((ARRf(i) > LlindarSuperior) && (ant == ARRf(i))) || ((ARRf(i) < LlindarInferior) && (ant == ARRf(i))))
    if (f(i) > LlindarSuperior || f(i) < LlindarInferior)
        finestra(i) = 1;
    else
        finestra(i) = 0;
    end
    fred(i) = f(i);
    ant = f(i);
end
for i = w + 1:length(f)
%     if (((f(i) > LlindarSuperior) && (ant == f(i))) || ((f(i) < LlindarInferior) && (ant == f(i))))
    if (f(i) > LlindarSuperior || f(i) < LlindarInferior) % anomalia
        if w > 1
            j = w; % comencem pel final
            while (finestra(j) == 1 && j > 1)
                j = j - 1;
            end
            if (j == 1 && finestra(j) == 1)
                fred(i) = f(i);  % s una fallada (massa retards seguits)
            else
                fred(i) = fred(i - 1);  % no hem esgotat tots els retards
            end
        else
            if (finestra(1) == 1)
                fred(i) = f(i);  % s una fallada
            else
                fred(i) = fred(i - 1);  % s un retard vlid
            end
        end
        % Actualitzem l'estat
        if w == 1
            finestra(1) = 1;
        else
            finestra(1:w - 1) = finestra(2:w);
            finestra(w) = 1;
        end
    else    % no hi ha cap anomalia
        fred(i) = f(i);
        % Actualitzem l'estat
        if w == 1
            finestra(1) = 0;
        else
            finestra(1:w - 1) = finestra(2:w);
            finestra(w) = 0;
        end
    end
	ant = f(i);
end